/*Version 1.0
 *Release Date: 03-28-06

Authors: George Karypis  (karypis@cs.umn.edu)	
         Huzefa Rangwala (rangwala@cs.umn.edu)     
LICENSE: Please read LICENSE.txt*/

/*
 * main.c
 *
 * This file is the entry point of aasim
 *
 *
 *
 */


#include <aasim.h>


/*************************************************************************
* This is the entry point of the vscluster program
**************************************************************************/
int main(int argc, char *argv[])
{
  int i, j, k;
  CtrlType ctrl;
  SeqDBType seqDB;
  MatType smat;

  parse_cmdline_aasim(&ctrl, argc, argv);

  /* Initialize the random-number generator */
  srand(ctrl.seed);


  SetUpScoringMatrices(&ctrl);

  /*------------------------------------------------------------------
   * Read the sequence database 
   *------------------------------------------------------------------*/
  ReadSequences(&ctrl, &seqDB);
  


  


  /*------------------------------------------------------------------
   * Compute the similarity between the sequences
   *------------------------------------------------------------------*/
  ComputeSeq2SeqSimilarities(&ctrl, &seqDB, &smat);

  /*------------------------------------------------------------------
   * Write the similarities to a file
   *------------------------------------------------------------------*/
  WriteSimMatrix(&ctrl, &seqDB, &smat);


}



