/*
 * defs.h
 *
 * This file contains various constant definitions
 *
 * Started 11/23/04
 * George
 *
 */

#define PSSMWIDTH               20      /* from PSI-BLAST */
#define FPTOL                   10e-5   /* The error tolerrance for FP comparisons. So far it affects trace-back */
#define FPEQUAL(a, b)           (fabs((a)-(b)) < FPTOL)      


#define MAXLINELEN              8192

/* What program am I running */
#define PRG_AASIM               1
#define PRG_PAIRSIM             2


/* Input parameters */
#define CMD_SIMTYPE             1
#define CMD_SMTYPE              2
#define CMD_KMERLEN             3
#define CMD_GOCOST              8
#define CMD_GECOST              9
#define CMD_SHIFT               12
#define CMD_HELP                90


/* Similarity Types */
#define SIMTYPE_KMERPSSM                4
#define SIMTYPE_SWPSSM                	11
#define SIMTYPE_BKMERPSSM               15
#define SIMTYPE_ABKMERPSSM              17



/* Scoring Matrices */
#define SMTYPE_BLOSUM62         2







/* The text labels for SimTypes*/
static char simtypenames[][20] = {"", "kmer-pssm",  "sw-pssm", "bkmer-pssm",
                                  "abkmer-pssm"};



