/*
 * proto.h
 *
 * This file contains various definitions
 *
 *
 */


/* io.c */
void ReadSequences(CtrlType *ctrl, SeqDBType *seqDB);
void ReadOneSequence_PSIBLAST(CtrlType *ctrl, SeqType *seq, char *filename, int *i2c, int *c2i);
void WriteSimMatrix(CtrlType *ctrl, SeqDBType *seqDB, MatType *mat);


/* util.c */
void LocalizeSequences(SeqDBType *sdb, char *alphabet);
SeqDBType *CreateSeqDB();
void InitSeqDB(SeqDBType *sdb);
void FreeSeqDB(SeqDBType *sdb, int freetop);
MatType *CreateMatrix();
void InitMatrix(MatType *sdb);
void FreeMatrix(MatType *sdb, int freetop);
void SetUpClasses(CtrlType *, SeqDBType *);
void PrintSeqType(SeqType *seq, int *i2c, int *c2i);


/* cmdline.c */
void parse_cmdline_aasim(CtrlType *ctrl, int argc, char *argv[]);



/* matrices.c */
void SetUpScoringMatrices(CtrlType *ctrl);


/* sim.c */
void ComputeSeq2SeqSimilarities(CtrlType *ctrl, SeqDBType *seqDB, MatType *smat);

void ComputeSimilaritiesKMERPSSM_FAST(CtrlType *ctrl, SeqDBType *seqDB, MatType *smat);

void ComputeSimilaritiesSWPSSM(CtrlType *ctrl, SeqDBType *seqDB, MatType *smat);

void ComputeSimilaritiesBKMERPSSM(CtrlType *ctrl, SeqDBType *seqDB, MatType *smat);

void ComputeSimilaritiesABKMERPSSM2(CtrlType *ctrl, SeqDBType *seqDB, MatType *smat);
void CreateSimMatrix(CtrlType *ctrl, SeqDBType *seqDB, MatType *smat, float **sims);
void ComputeP2PScore(CtrlType *ctrl, float **p2pscore, int ilen, int **ipssm, int **ipsfm, int jlen, int **jpssm, int **jpsfm);



float SWAlign_PSSM(int ilen, int jlen, float **p2pscore, float gocost, float gecost, int *r_lalen, int *ila, int *jla);



